/**
 * \file qoobarglobals.h
 * Contains types and enums that are used thoughout qoobar.
 *
 * \b Project: Qoobar
 * \author Alex Novichkov
 * \date 8 Dec 2010
 *
 * Copyright (C) 2011  Alex Novichkov
 *
 * This file is part of Qoobar.
 *
 * Qoobar is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Qoobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef QOOBARGLOBALS_H
#define QOOBARGLOBALS_H

#include <QStringList>

QString formatLength(int i);
QString tagByID(int id);
QString untranslatedTagByID(int id);
bool programInstalled(const QString &program, QString *path);
QStringList musicalFilters();
void processDir(const QString &file, QStringList &files, bool includeSubfolders);
QStringList expandFilesNames(const QStringList &filesNames, bool includeSubfolders);
#endif // QOOBARGLOBALS_H
