#include "tagparser.h"

//#include "placeholders.h"

void TagParser::updateSource(QString &pattern, QStringList &source)
{
    pattern.replace('\\','/');
    while (pattern.startsWith('/')) pattern.remove(0,1);
    int count = source.size();

    int sourcesDirCount=100000;
    for (int i=0; i<count; ++i) {
        int j=source.at(i).count('/');
        if (j<sourcesDirCount) sourcesDirCount=j;
    }
    sourcesDirCount=qMin(sourcesDirCount, pattern.count('/'))+1;

    for (int i=0; i<count; ++i) {
        if (!source.at(i).isEmpty()) {
            source[i]=source.at(i).section('/',-1*sourcesDirCount);
        }
    }
    pattern=pattern.section('/',-1*sourcesDirCount);
}

//QStringList TagParser::getDelimiters(const QString &pattern)
//{
//    QString placeholders = Placeholders::getWritablePlaceholders()
//            + Placeholders::getVoidPlaceholder();
//    return pattern.split(QRegExp(QString("%[%1]").arg(placeholders)),QString::SkipEmptyParts);
//}

//QList<int> TagParser::getTagsOrder(const QString &pattern)
//{
//    QString placeholders = Placeholders::getWritablePlaceholders()
//            + Placeholders::getVoidPlaceholder();
//    QList<int> tagsOrder;
//    int pos=0;
//    while (pos>=0) {
//        pos=pattern.indexOf("%",pos);
//        if (pos==-1) break;
//        if (pos<pattern.length()-1)
//            if (placeholders.contains(pattern.mid(pos+1,1)))
//                tagsOrder << Placeholders::delToId(pattern.mid(pos+1,1));
//        pos+=2;
//    }
//    return tagsOrder;
//}

//void TagParser::parse(QString source, QStringList delimiters, QList<int> tagsOrder, Tag &tag, QList<int> &map)
//{
//    if (source.isEmpty()) {
//        source = " ";
//        if (!delimiters.isEmpty())
//            source.append(delimiters.join(" ") + " ");
//    }
//    while (!delimiters.isEmpty() && !source.isEmpty()) {//chop piece by piece
//        QString delimiter=delimiters.takeFirst();

//        int pos=source.indexOf(delimiter);
//        if (pos==-1) {//no such a delimiter in the input string
//            if (!tagsOrder.isEmpty()) tagsOrder.takeFirst();
//            continue;
//        }
//        if (pos==0) {//input string starts with delimiter
//            source.remove(0,delimiter.length());
//            continue;
//        }
//        if (tagsOrder.isEmpty()) break;
//        int lastDel=tagsOrder.takeFirst();
//        tag.setTag(lastDel,source.mid(0,pos));
//        if (!map.contains(lastDel)) map.append(lastDel);
//        if (tagsOrder.isEmpty()) break;
//        source = source.remove(0,pos+delimiter.length());
//    }
//    if (!source.isEmpty() && !tagsOrder.isEmpty()) {
//        int lastDel=tagsOrder.takeFirst();
//        tag.setTag(lastDel,source);
//        if (!map.contains(lastDel)) map.append(lastDel);
//    }
//}

#include <QStack>
#include <QtDebug>

PairList TagParser::parse(QString source, QString pattern)
{
    PairList result;

    int startPattern = 0;
    int endPattern=pattern.length();
    int startSource=0;

    QStringRef stack;

    while (startPattern<endPattern) {
        QChar c = pattern.at(startPattern);
        if (c=='%') {
            stack=pattern.midRef(startPattern,2);
            startPattern+=2;
        }
        else {
            int next = pattern.indexOf('%',startPattern);
            QString delim = pattern.mid(startPattern, next-startPattern);
            int sourcePos=source.indexOf(delim, startSource);
            if (sourcePos!=-1) {
                QString s = source.mid(startSource, sourcePos-startSource);
                result << StringPair(stack.toString(), s);
                startSource = sourcePos+delim.length();
                startPattern += delim.length();
            }
            else {
                QString s = source.mid(startSource, -1);
                result << StringPair(stack.toString(), s);
                startPattern = endPattern;
            }
            stack.clear();
        }
    }
    if (!stack.isEmpty())
        result << StringPair(stack.toString(), source.mid(startSource, -1));

    return result;
}

